//////////////////////////////////////////////////////////////////////////////////
//
//Create your FSM and any other circuit to generate all your control signals here.
//You can modify any part of this module but do not remove or modify any
//of the PORT signals that are already there.
//You can add more signals in the module interface.
/////////////////////////////////////////////////////////////////////////////////
// 	The initialize and lode mode register waveforms are given in page 37 of the datasheet
//	
//     Power up -> NOP for min 100us -> precharge -> NOP 
//	-> autorefresh -> NOP ->autorefresh -> NOP  
//	->Load Mode Register -> NOP -> active operations
//
//	SDRAM Configuration
//	a.	Burst length of 4 for both read and write
//	b.	Sequential order of bursts
//	c.	CAS latency of 2
//	d.	Standard operation
//
///////////////////////////////////////////////////////////////////////



// SDRAM control signals generation.
module sdram_cntrl (	 
/////////////////////////////////////////////
//Do not modify or remove any of these signals
		 RAM_D_EN,		// to SDRAM
		 RAM_CLK,		// to SDRAM
		 RAM_CLKE,		// to SDRAM
		 RAM_DQMH,		// to SDRAM
		 RAM_DQML,		// to SDRAM
		 RAM_CS,		// to SDRAM
		 RAM_RAS,		// to SDRAM
		 RAM_CAS,		// to SDRAM
		 RAM_WE,		// to SDRAM
		 RAM_BA,		// to SDRAM
		 RAM_A,		// to SDRAM
		 CLK_IN, 		//from FPGA
		 RESET_IN,		//from FPGA
		 DEBUG2, 		// to pins probe
		 time_sel		//from dip-switches, selects programmable delay
//////////////////////////////////////////////////////
//you can add your own signals here
		 );
   
   output 	 RAM_D_EN;   
   output 	 RAM_CLK;
   output 	 RAM_CLKE;
   output 	 RAM_DQMH;
   output 	 RAM_DQML;
   output 	 RAM_CS;
   output 	 RAM_RAS;
   output 	 RAM_CAS;
   output 	 RAM_WE;
   output [1:0]  RAM_BA;
   output [11:0] RAM_A;
   input 	 CLK_IN;
   input 	 RESET_IN;
   inout [31:0]  DEBUG2;
   input [15:0] time_sel;
   
  

/////////////////////////////////////////////////////////////////
//Create your FSM here
   


////////////////////////////////////////////////////////////////////
//generate control signals for the pn_generators: 


////////////////////////////////////////////////////////////////////
//generate control signals for the FIFOs: 


////////////////////////////////////////////////////////////////////////
// Use time_sel here to start reading after a programmable delay


//////////////////////////////////////////////////////////////////////////////////////
//assign your DEBUG2 pins here
//  assign DEBUG2[14:0] = {read, write, active, start_rd, end_wr, end_rd, clk4, CS, NS};

endmodule
